/**************************************************************************
*
*	MainForm.cs
*
*	Main form for interactive robot sample programme
*
*	Author: Saxon Druce
*
*	Copyright (c) 2004 Block Software Pty Ltd
*
**************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using ControllerNet;

namespace InteractiveRobot
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components = null;

		/// <summary>
		/// Controls
		/// </summary>
		private System.Windows.Forms.Button m_buttonStart;
		private System.Windows.Forms.TextBox m_textBoxName;
		private System.Windows.Forms.GroupBox m_groupBoxRobotDetails;
		private System.Windows.Forms.Label m_labelName;
		private System.Windows.Forms.TextBox m_textBoxOwner;
		private System.Windows.Forms.Label m_labelOwner;
		private System.Windows.Forms.GroupBox m_groupBoxConnection;
		private System.Windows.Forms.TextBox m_textBoxServer;
		private System.Windows.Forms.Label m_labelServer;
		private System.Windows.Forms.TextBox m_textBoxPort;
		private System.Windows.Forms.Label m_labelPort;
		private System.Windows.Forms.Button m_buttonClose;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_buttonStart = new System.Windows.Forms.Button();
			this.m_buttonClose = new System.Windows.Forms.Button();
			this.m_groupBoxRobotDetails = new System.Windows.Forms.GroupBox();
			this.m_labelName = new System.Windows.Forms.Label();
			this.m_textBoxName = new System.Windows.Forms.TextBox();
			this.m_textBoxOwner = new System.Windows.Forms.TextBox();
			this.m_labelOwner = new System.Windows.Forms.Label();
			this.m_groupBoxConnection = new System.Windows.Forms.GroupBox();
			this.m_textBoxServer = new System.Windows.Forms.TextBox();
			this.m_labelServer = new System.Windows.Forms.Label();
			this.m_textBoxPort = new System.Windows.Forms.TextBox();
			this.m_labelPort = new System.Windows.Forms.Label();
			this.m_groupBoxRobotDetails.SuspendLayout();
			this.m_groupBoxConnection.SuspendLayout();
			this.SuspendLayout();
			// 
			// m_buttonStart
			// 
			this.m_buttonStart.Location = new System.Drawing.Point(104, 168);
			this.m_buttonStart.Name = "m_buttonStart";
			this.m_buttonStart.Size = new System.Drawing.Size(72, 23);
			this.m_buttonStart.TabIndex = 0;
			this.m_buttonStart.Text = "Start";
			this.m_buttonStart.Click += new System.EventHandler(this.m_buttonStart_Click);
			// 
			// m_buttonClose
			// 
			this.m_buttonClose.Location = new System.Drawing.Point(184, 168);
			this.m_buttonClose.Name = "m_buttonClose";
			this.m_buttonClose.Size = new System.Drawing.Size(72, 23);
			this.m_buttonClose.TabIndex = 1;
			this.m_buttonClose.Text = "Close";
			this.m_buttonClose.Click += new System.EventHandler(this.m_buttonClose_Click);
			// 
			// m_groupBoxRobotDetails
			// 
			this.m_groupBoxRobotDetails.Controls.Add(this.m_labelName);
			this.m_groupBoxRobotDetails.Controls.Add(this.m_textBoxName);
			this.m_groupBoxRobotDetails.Controls.Add(this.m_textBoxOwner);
			this.m_groupBoxRobotDetails.Controls.Add(this.m_labelOwner);
			this.m_groupBoxRobotDetails.Location = new System.Drawing.Point(8, 88);
			this.m_groupBoxRobotDetails.Name = "m_groupBoxRobotDetails";
			this.m_groupBoxRobotDetails.Size = new System.Drawing.Size(248, 72);
			this.m_groupBoxRobotDetails.TabIndex = 3;
			this.m_groupBoxRobotDetails.TabStop = false;
			this.m_groupBoxRobotDetails.Text = "Robot Details";
			// 
			// m_labelName
			// 
			this.m_labelName.Location = new System.Drawing.Point(8, 16);
			this.m_labelName.Name = "m_labelName";
			this.m_labelName.Size = new System.Drawing.Size(48, 16);
			this.m_labelName.TabIndex = 1;
			this.m_labelName.Text = "Name";
			// 
			// m_textBoxName
			// 
			this.m_textBoxName.Location = new System.Drawing.Point(64, 16);
			this.m_textBoxName.Name = "m_textBoxName";
			this.m_textBoxName.Size = new System.Drawing.Size(176, 20);
			this.m_textBoxName.TabIndex = 0;
			this.m_textBoxName.Text = "Interactive Robot";
			// 
			// m_textBoxOwner
			// 
			this.m_textBoxOwner.Location = new System.Drawing.Point(64, 40);
			this.m_textBoxOwner.Name = "m_textBoxOwner";
			this.m_textBoxOwner.Size = new System.Drawing.Size(176, 20);
			this.m_textBoxOwner.TabIndex = 1;
			this.m_textBoxOwner.Text = "Saxon";
			// 
			// m_labelOwner
			// 
			this.m_labelOwner.Location = new System.Drawing.Point(8, 40);
			this.m_labelOwner.Name = "m_labelOwner";
			this.m_labelOwner.Size = new System.Drawing.Size(48, 16);
			this.m_labelOwner.TabIndex = 1;
			this.m_labelOwner.Text = "Owner";
			// 
			// m_groupBoxConnection
			// 
			this.m_groupBoxConnection.Controls.Add(this.m_textBoxServer);
			this.m_groupBoxConnection.Controls.Add(this.m_labelServer);
			this.m_groupBoxConnection.Controls.Add(this.m_textBoxPort);
			this.m_groupBoxConnection.Controls.Add(this.m_labelPort);
			this.m_groupBoxConnection.Location = new System.Drawing.Point(8, 8);
			this.m_groupBoxConnection.Name = "m_groupBoxConnection";
			this.m_groupBoxConnection.Size = new System.Drawing.Size(248, 72);
			this.m_groupBoxConnection.TabIndex = 2;
			this.m_groupBoxConnection.TabStop = false;
			this.m_groupBoxConnection.Text = "Connection";
			// 
			// m_textBoxServer
			// 
			this.m_textBoxServer.Location = new System.Drawing.Point(64, 16);
			this.m_textBoxServer.Name = "m_textBoxServer";
			this.m_textBoxServer.Size = new System.Drawing.Size(176, 20);
			this.m_textBoxServer.TabIndex = 0;
			this.m_textBoxServer.Text = "localhost";
			// 
			// m_labelServer
			// 
			this.m_labelServer.Location = new System.Drawing.Point(8, 16);
			this.m_labelServer.Name = "m_labelServer";
			this.m_labelServer.Size = new System.Drawing.Size(48, 16);
			this.m_labelServer.TabIndex = 1;
			this.m_labelServer.Text = "Server";
			// 
			// m_textBoxPort
			// 
			this.m_textBoxPort.Location = new System.Drawing.Point(64, 40);
			this.m_textBoxPort.Name = "m_textBoxPort";
			this.m_textBoxPort.Size = new System.Drawing.Size(176, 20);
			this.m_textBoxPort.TabIndex = 1;
			this.m_textBoxPort.Text = "9386";
			// 
			// m_labelPort
			// 
			this.m_labelPort.Location = new System.Drawing.Point(8, 40);
			this.m_labelPort.Name = "m_labelPort";
			this.m_labelPort.Size = new System.Drawing.Size(48, 16);
			this.m_labelPort.TabIndex = 1;
			this.m_labelPort.Text = "Port";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(264, 198);
			this.Controls.Add(this.m_groupBoxConnection);
			this.Controls.Add(this.m_groupBoxRobotDetails);
			this.Controls.Add(this.m_buttonClose);
			this.Controls.Add(this.m_buttonStart);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Interactive Robot";
			this.m_groupBoxRobotDetails.ResumeLayout(false);
			this.m_groupBoxConnection.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		/// <summary>
		/// Called when the start button is clicked
		/// </summary>
		private void m_buttonStart_Click(object sender, System.EventArgs e)
		{
			try
			{
				// create control form
				ControlForm controlForm = new ControlForm(
					m_textBoxServer.Text,
					Int32.Parse(m_textBoxPort.Text),
					m_textBoxName.Text,
					m_textBoxOwner.Text);

				// show it
				controlForm.ShowDialog();

				// get rid of it
				controlForm.Dispose();
			}
			catch (Exception ex)
			{
				MessageBox.Show(
					ex.Message, 
					"Error", 
					MessageBoxButtons.OK, 
					MessageBoxIcon.Error);
			}
		}

		/// <summary>
		/// Called when the close button is clicked
		/// </summary>
		private void m_buttonClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
